<template>
  <header class="TopBar">
    <router-link :to="ROUTES.HOME" class="TopBar__Logo" />
    <h1 class="TopBar__Title">{{ title }}</h1>

    <p-Button
      class="TopBar__AccountMenu"
      type="button"
      :label="settings.user.name || settings.user.email"
      aria-haspopup="true"
      aria-controls="overlay_menu"
      @click="toggle"
    >
      <UserAvatar :user-id="settings.user.id" />
    </p-Button>
    <p-Menu id="overlay_menu" ref="menu" :model="items" :popup="true" />
  </header>
</template>

<script lang="ts" setup>
import { computed, ref } from 'vue'
import { useI18n } from 'vue-i18n'
import { Settings } from '@/components/bars/LinkItems'
import { LogOut } from '@/components/bars/ActionItems'
import { ROUTES } from '@/plugins'
import { translate } from '@/components/bars/MenuItem'
import { getTitle } from '@/components/bars/useTitle'
import { UserAvatar } from '@/components/avatar'

import { injectStrict } from '@/injectStrict'
import { SettingsKey } from '@/provided'

const settings = injectStrict(SettingsKey)

const { t } = useI18n()
const title = getTitle()
const items = computed(() => [translate(Settings, t), translate(LogOut, t)])
const menu = ref()

const toggle = (event: Event) => menu.value.toggle(event)
</script>

<style lang="scss" scoped>
@use 'src/style/variables' as v;
@use 'src/style/mixins' as m;

.TopBar {
  $height: 50px;

  @include m.mobile {
    display: none;
  }

  display: inline-flex;
  grid-area: topBar;
  align-items: center;
  justify-content: space-between;
  height: $height;
  background-color: var(--primary-color);
  color: white;

  &__Title {
    flex: 1 1;
    margin-left: v.$spacing;
    font-weight: 500;
    font-size: 1.2rem;
  }

  &__Logo {
    display: inline-flex;
    flex: 0 0;
    align-items: center;
    justify-content: center;
    min-width: 58px;
    padding: v.$spacing;
    background: var(--logoUrl);
    background-position: center;
    background-size: auto;
    background-repeat: no-repeat;
  }

  &__AccountMenu {
    padding: v.$spacing-2 v.$spacing;
    border: none;
    color: var(--text-color);
  }
}
</style>
